--Icon Class

Icon=class(Turbine.UI.Control)
function Icon:Constructor(i)
	--i is the reference of the buff
	local thiseffect=effects:Get(i)	--Get the effect
		self.Name=				thiseffect:GetName()
		self.Duration=			thiseffect:GetDuration()
		self.Description=	thiseffect:GetDescription()
		self.Category=		thiseffect:GetCategory()
		self.Icon=				thiseffect:GetIcon()
		self.Start=				thiseffect:GetStartTime()
		self.ID=					thiseffect:GetID()
		self.IsDebuff=			thiseffect:IsDebuff()
		
	Turbine.UI.Control.Constructor( self )
	
	self:SetSize(32,37)
	self:SetMouseVisible(true)
	
	self.Icon=Turbine.UI.Control()
	self.Icon:SetParent(self)
	self.Icon:SetSize ( 32,32)
	self.Icon:SetPosition(0,5)
	
	self.Icon:SetBackground (thiseffect:GetIcon())
	
	self.MouseEnter=function(sender,args)
		--Show Tooltip
		local x,y=Turbine.UI.Display.GetMousePosition()
				local w,h=Turbine.UI.Display.GetSize()
				if x+200>w then x=w-200 end
				if y+100>h then y=h-100 end
				if x<0 then x=0 end
				if y<0 then y=0 end
				Tooltip:SetPosition(x+1,y+1)
				
		Tooltip:SetVisible(true)
		Text1:SetText(self.Name)
		local txt
		if self.Duration<6000 then
			if self.Duration>60 then txt=math.floor(self.Duration/60).." mins, " else txt=self.Duration.." secs, " end
			if self.time>60 then txt=txt..math.floor(self.time/60).." mins left" else txt=txt..self.time.." secs left" end
		else
			txt="No/Very Long Duration"
		end
		Text2:SetText(txt)
		Text3:SetText(self.Description)
	end
	
	self.MouseLeave=function(sender,args)
		--Hide Tooltip
		Tooltip:SetVisible(false)
	end
	
	self.Icon.MouseClick=function(sender,args)
		--Here ready for a menu to "Ignore"
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
		
			local contextMenu = Turbine.UI.ContextMenu()
			contextMenu.items = contextMenu:GetItems()

			local option1 = Turbine.UI.MenuItem("Ignore this buff", true)
			option1.Click = function () 
				ignorelist[#ignorelist+1]=self.Name
				addall()
			end
			
			contextMenu.items:Add(option1)

			if #ignorelist>0 then
				local option2 = Turbine.UI.MenuItem("Currently Ignored")
				contextMenu.SubMenuItems = option2:GetItems()
				local suboption={}
				for i=1,#ignorelist do
					suboption[i] = Turbine.UI.MenuItem(ignorelist[i],true)
					suboption[i].Click = function () table.remove(ignorelist,i) addall() end

					contextMenu.SubMenuItems:Add(suboption[i])
				end
			contextMenu.items:Add(option2)
			end
		
			contextMenu:ShowMenu()
		end
	end
	
	
		if self.IsDebuff  then 
				self.Frame=4
			else 
				self.Frame=1
			end
		Insert (self,self.Frame)
	
	--Only bother with a timer if the Duration is less than 6000s.
	if self.Duration <6000 then
	
		self.Backdrop=Turbine.UI.Control()
			self.Backdrop:SetSize(32,5)
			self.Backdrop:SetBackColor(Turbine.UI.Color(1,0,0,0))
			self.Backdrop:SetPosition(0,0)
			self.Backdrop:SetVisible(true)
			self.Backdrop:SetParent(self)
	
		self.Bar=Turbine.UI.Control()
			self.Bar:SetSize(32,5)
			self.Bar:SetBackColor(Turbine.UI.Color(1,1,0,0))
			self.Bar:SetPosition(0,0)
			self.Bar:SetVisible(true)
			self.Bar:SetParent(self)
		
		self.Text=Turbine.UI.Label()
			self.Text:SetParent( self )
			self.Text:SetPosition( 0, 24 )
			self.Text:SetSize( 32,21 )
			self.Text:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
			self.Text:SetFont(Turbine.UI.Lotro.Verdana10)
			self.Text:SetText("")
			self.Text:SetOutlineColor( Turbine.UI.Color( 0.8,0, 0, 0 ) )
			self.Text:SetFontStyle( Turbine.UI.FontStyle.Outline )
		
		self:SetWantsUpdates(true)
	end
end

function Icon:Update()
	local Time = Turbine.Engine.GetGameTime()
    local elapsed = Time - self.Start
    if (elapsed > self.Duration) then
        self:SetWantsUpdates(false)
    end
	
	self.time=math.ceil(self.Duration-elapsed)
	
	if self.time<30 then		--Show numeric display when at less than 30s of Duration left
		self.Text:SetText(self.time)
	end

	local fract=((self.time)/self.Duration)*32

	self.Bar:SetWidth(fract)
	
	--Assign to bar based on Duration
	local frame
				if self.time<=short then
				frame=3		--Buffs less than "short" seconds are "Short"
			elseif self.time<=medium then		
				frame=2		--Buffs less than "medium" seconds are "Medium"
			else
				frame=1		--Other buffs are "long"
			end
	
	--If it is a debuff just keep it in the debuff frame
	if self.IsDebuff  then frame=4 end
	
	if self.Frame ~= frame then
		if self.Frame~=nil then 
			BuffFrame[self.Frame].ListBox:RemoveItem(self)
			BuffFrame[self.Frame].Window:SetBackColor(Turbine.UI.Color(0,0,0,0))
		end
		self.Frame=frame
		Insert(self,self.Frame)
	end
end

--Direction names
dir={"Right","Left","Bottom","Top"}

--Frame Creation
Frame=class(Turbine.UI.Window)
import "JackdawPlugins.BuffFrame.Snapper"

function Frame:Constructor(name,o)

	--Constructs the frame and sets many procs BUT not the stretch mode! This is set elsewhere...

	self.Window=Turbine.UI.Window()
		self.Window:SetVisible(true)
		self.Window.DragBar = Deusdictum.UI.DragBar( self.Window,name)
		self.Window.DragBar:SetRotator(true)
		self.Window:SetPosition(100,100)
		self.Window:SetSize(320,370)
		self.Window:SetOpacity(1)
		self.Window:SetMouseVisible(false)
		--self.Window:SetStretchMode(1)	This is now done in the loading procedure.
	
	self.Cover=Turbine.UI.Control()
		self.Cover:SetParent(self.Window)
		self.Cover:SetSize(320,370)
		self.Cover:SetMouseVisible(false)
		self.Cover:SetZOrder(-5)

	self.Window.DragEnable =function(Sender,Args)  self.Cover:SetMouseVisible(true) self.Cover:SetZOrder(10) self.Window:SetBackColor(Turbine.UI.Color(0.5,1,1,1)) self.Window.DragBar:Refresh() end
	self.Window.DragDisable =function(Sender,Args) self.Cover:SetMouseVisible(false) self.Cover:SetZOrder(-5) self.Window:SetBackColor(Turbine.UI.Color(0,0,0,0)) self.Window.DragBar:Refresh() end
	
	self.Window.RotateStart =function(Sender,Args)
		
		local o=self.Window.o+1
	
		if o>4 then o=1 end

		Turbine.Shell.WriteLine("You may need to reload plugins after rotating. This frame now filling from the "..dir[o])
		
		self.Window.o=o
		
		if o==1 or o==3 then
			self.ListBox:SetReverseFill( true )
		else
			self.ListBox:SetReverseFill( false )
		end
		
		if o==1 or o== 2 then
			self.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		else
			self.ListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
		end
			
		local sf
		if o==3 then
			sf=self.Window.xs/320
			self.Window.xs,self.Window.ys=32*sf,370*sf
		end
		if o==1 then
			sf=self.Window.ys/370
			self.Window.xs,self.Window.ys=320*sf,37*sf
		end
		
		self.Window:SetSize(self.Window.xs,self.Window.ys)
		self.Window.DragBar:Refresh()
	end
		
	--Resizing functions
	self.Cover.MouseDown=function(sender,args)
		if self.Window.DragBar:IsVisible() then
			if ( args.Button == Turbine.UI.MouseButton.Left ) then
				self.Window:SetBackColor(Turbine.UI.Color(0.5,1,1,1))
				Moving=true
			else
				shown=not shown
				Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, shown );
			end
		end		
	end
	
	self.Cover.MouseUp =function(sender,args)
		if Moving then 
			Moving=false
		end
	end
	
	self.Cover.MouseMove = function(sender,args)
		if Moving then
			local x,y=self.Window:GetMousePosition()
			--If shift key is down then snap the resize to a grid
			if self.Window:IsShiftKeyDown() then x=math.ceil(x/16)*16 y=math.ceil(y/16)*16 end
			
			if self.Window.o==1 or self.Window.o==2 then
				if x<160 then x=160 end
				y=x/320*37
			else
				if y<160 then y=160 end
				x=y/370*32
			end
			
			self.Window:SetSize(x,y)
			self.Window.xs=x
			self.Window.ys=y
			self.Window.DragBar:Refresh()
		end
	end
	
	self.ListBox = Turbine.UI.ListBox()
	self.ListBox:SetParent( self.Window )
	self.ListBox:SetPosition( 0, 0 )
	self.ListBox:SetSize( 320,370)
	self.ListBox:SetMaxItemsPerLine(10)
	self.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
	self.ListBox:SetMouseVisible(false)
	self.ListBox:SetReverseFill( true )
	
		--These functions get around GetWidth and GetSIze returning incorrect values because of the scaling.
	function self.Window:GetWidth()
		return self.xs or 320
	end
	function self.Window:GetRight()
		return self.xs+self:GetLeft()
	end
	function self.Window:GetBottom()
		return self.ys+self:GetTop()
	end
	function self.Window:GetHeight()
		return self.ys or 37
	end
	function self.Window:GetSize()
		return self.xs or 320 ,self.ys or 37
	end
	
	self:Snapper()
end

function Frame:SetOrientation(o)
	--Changes the orientation of the window and listbox to default values based on o.
	
	self.Window.o=o
	
	if o==1 or o==2 then 
		self.Window:SetSize	(320,37) 
		self.Cover:SetSize		(320,37)
		self.ListBox:SetSize	(320,37) 
	else 
		self.Window:SetSize	(32,370) 
		self.Cover:SetSize		(32,370) 
		self.ListBox:SetSize	(32,370) 
	end
	
	if o==1 or o==3 then
		self.ListBox:SetReverseFill( true )
	else
		self.ListBox:SetReverseFill( false )
	end
	
	if o==1 or o== 2 then
		self.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
	else
		self.ListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
	end
end

--Callback handler - Due to Pengoros... Many thanks!
	function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback)
        else
            object[event] = {object[event], callback}
        end
    end
    return callback
end

function AddEffects(Index)
		--First check that this effect is not already on the player.
		local thiseffect=effects:Get(Index)	--Get the effect
		
			local Name=thiseffect:GetName()
			
			--First check if the buff is on the ignore list. If it is return without adding.
			for i=1,#ignorelist do
				if ignorelist[i]==Name then return end
			end
			
			local found=false
			
			for i=1,#icons do
				--If it is, then update the start time...
				if icons[i].Name ==Name then found=true icons[i].Start=thiseffect:GetStartTime() if icons[i].Text~=nil then icons[i].Text:SetText("") end break end
			end
			--...otherwise insert the effect.
			if not(found) then table.insert(icons,Icon(Index)) end
		end

function RemoveEffects()
	--This function scans the effects and finds matches for the current effects on the player.
	for i in pairs(icons) do
		local found=false
		for j=1,effects:GetCount() do
			local thiseffect=effects:Get(j)
			local Name=thiseffect:GetName()
			if icons[i].Name==Name then found=true break end
		end
		if not(found) then
			icons[i]:SetWantsUpdates(false)
			BuffFrame[icons[i].Frame].ListBox:RemoveItem(icons[i])
			BuffFrame[icons[i].Frame].Window:SetBackColor(Turbine.UI.Color(0,0,0,0))
			table.remove(icons,i)
			--break	--We can leave the loop - the removed buff has been found. This will only cause a problem if two buffs go and only one call gets made. NOTE: Did cause trouble on my RK, so remmed out!
		end
	end
end

function Insert(icon,frame)
	BuffFrame[frame].ListBox:AddItem(icon)
end

--This function clears all current icons and then rebuilds them.
--This is used by the ignore functions, and upon first loading the plugin.
function addall()
	--First clear all
	for i=1,#icons do
		icons[1]:SetWantsUpdates(false)
		table.remove(icons,1)
	end
	for i=1,#BuffFrame do
		BuffFrame[i].ListBox:ClearItems()
		BuffFrame[i].Window:SetBackColor(Turbine.UI.Color(0,0,0,0))
	end
	--then load all
	for j=1,effects:GetCount() do
		AddEffects(j)
	end
end