import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"
import "Deusdictum.UI.Dragbar"
import "JackdawPlugins.BuffFrame.Function"

--Table to hold the "Icons" - the buff icons, plus timer bar.
icons={}

--Create the three buff frames. Note times (in seconds) here also.
BuffFrame={}
	
BuffFrame[1]=Frame("Long Duration")
BuffFrame[2]=Frame("Medium Duration")		medium=180
BuffFrame[3]=Frame("Short Duration")			short=30
BuffFrame[4]=Frame("DeBuffs")

Player = Turbine.Gameplay.LocalPlayer.GetInstance()
effects = Player:GetEffects()

--Event handlers
handle1 = AddCallback(effects, "EffectAdded", function(sender, args ) AddEffects(args.Index) end)
handle2 = AddCallback(effects, "EffectRemoved", function(sender, args ) RemoveEffects() end)
handle3 = AddCallback(effects, "EffectsCleared", function(sender, args ) RemoveEffects() end)

--Tooltip
Tooltip={}
Tooltip=Turbine.UI.Window()
	Tooltip:SetZOrder(999)
	Tooltip:SetSize(200,110)
	Tooltip:SetMouseVisible(false)

Text1=	Turbine.UI.Label()
	Text1:SetParent( Tooltip )
	Text1:SetPosition( 0, 0 )
	Text1:SetSize( 200, 20 )
	Text1:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) )
	Text1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
Text2=	Turbine.UI.Label()
	Text2:SetParent( Tooltip )
	Text2:SetPosition( 0, 20 )
	Text2:SetSize( 200, 20 )
	Text2:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) )
	Text2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
Text3=	Turbine.UI.Label()
	Text3:SetParent( Tooltip )
	Text3:SetPosition( 0, 40 )
	Text3:SetSize( 200, 70 )
	Text3:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) )
	Text3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )

--Load and/or save
local BuffFrameData=Turbine.PluginData.Load( Turbine.DataScope.Character, "BuffFrame" )

	if BuffFrameData~=nil then
		for i=1,#BuffFrameData do
			BuffFrame[i].Window:SetPosition(BuffFrameData[i].x,BuffFrameData[i].y)
			BuffFrame[i].Window.xs,BuffFrame[i].Window.ys=BuffFrameData[i].xs,BuffFrameData[i].ys
			if BuffFrameData[i].xs==nil then BuffFrame[i].Window.xs,BuffFrame[i].Window.ys=320,37 end
			
			BuffFrame[i]:SetOrientation(BuffFrameData[i].o)
			
			BuffFrame[i].Window:SetStretchMode(1)
			BuffFrame[i].Window:SetSize(BuffFrame[i].Window.xs,BuffFrame[i].Window.ys)
		end
		ignorelist=BuffFrameData[1].ignorelist
		if ignorelist==nil then 	ignorelist={} end
		shown=BuffFrameData[1].shown
	else
		for i=1,4 do
			BuffFrame[i].Window:SetPosition(0,37*(i-1))
			BuffFrame[i].Window.xs,BuffFrame[i].Window.ys=320,37
			
			BuffFrame[i]:SetOrientation(2)
			
			BuffFrame[i].Window:SetStretchMode(1)
			BuffFrame[i].Window:SetSize(320,37)
		end
		ignorelist={}
		shown=true
	end
	
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, shown )


	Plugins["BuffFrame"].Unload = function( sender, args )
		Turbine.Shell.WriteLine("Saved Buff Frame Data")
		BuffFrameData={}
		for i=1,#BuffFrame do
			BuffFrameData[i]={}
			BuffFrameData[i].x,BuffFrameData[i].y=BuffFrame[i].Window:GetPosition()
			BuffFrameData[i].xs,BuffFrameData[i].ys=BuffFrame[i].Window.xs,BuffFrame[i].Window.ys
			BuffFrameData[i].o=BuffFrame[i].Window.o
		end
			BuffFrameData[1].shown=shown
			BuffFrameData[1].ignorelist=ignorelist
		Turbine.PluginData.Save( Turbine.DataScope.Character, "BuffFrame", BuffFrameData )
	end

--Add all the effects currently on the player.
addall()