--Snapping one BuffFrame to any near it.

--Need to detect edges of other BuffFrames
--When current BuffFrame is let go of, need to detect if another BuffFrame is near by and snap to it, left to right or right to left, top to bottom or bottom to top

function Frame:Snapper()
	--Set how near BuffFrames have to be to each other for the snapping function to fire.
	local near=10
	
	self.Window.PositionChanged=function (sender,args)
if not (loading) then	
	--If the ctrl key is being held down then snap to a background grid that is 16x16
	if self.Window:IsAltKeyDown() and not(loading) then
		local x,y=self.Window:GetLeft(),self.Window:GetTop()
		x=math.ceil(x/16)*16 y=math.ceil(y/16)*16
		return self.Window:SetPosition(x,y)
	end
	
	--Snap to other BuffFrames if the shift key is held down, otherwise don't!

	if self.Window:IsShiftKeyDown() then
		--New idea. Compute the shortest distance between this rectangle and every other. The one it is closest to, that is not istelf, is the one it will snap to.
			
			x1,y1=self.Window:GetLeft(),self.Window:GetTop()
			x2,y2=self.Window:GetRight(),self.Window:GetTop()
			x3,y3=self.Window:GetLeft(),self.Window:GetBottom()
			x4,y4=self.Window:GetRight(),self.Window:GetBottom()
			list1={{x1,y1},{x2,y2},{x3,y3},{x4,y4}}
			
			local mindist=2000
			local index=nil
			for i=1,#BuffFrame do
				if BuffFrame[i]~=nil then
				if BuffFrame[i].Window~=nil then
					x5,y5=BuffFrame[i].Window:GetLeft(),BuffFrame[i].Window:GetTop()
					x6,y6=BuffFrame[i].Window:GetRight(),BuffFrame[i].Window:GetTop()
					x7,y7=BuffFrame[i].Window:GetLeft(),BuffFrame[i].Window:GetBottom()
					x8,y8=BuffFrame[i].Window:GetRight(),BuffFrame[i].Window:GetBottom()
					--Don't compare with self!
					if not(x1==x5 and x6==x2 and x3==x7 and x4==x8 and	y1==y5 and y6==y2 and y3==y7 and y4==y8) then 
						list2={{x5,y5},{x6,y6},{x7,y7},{x8,y8}}
						local d=rectdistance(list1,list2)
						if d<mindist then mindist=d index=i end
					end
				end
				end
			end
			
			--If there is no other BuffFrame, or the minimum distance is greater than near, or we are actually touching! then just return
			if index==nil or mindist>near then return end

			
			--Otherwise time for a snap! This is where I feel work is needed. It is messy, as it belongs (mainly) to the old Snapper.
				local l=self.Window:GetLeft() 
				local r=self.Window:GetRight() 
				local t=self.Window:GetTop() 
				local b=self.Window:GetBottom() 
				local w=self.Window:GetWidth() 
				local h=self.Window:GetHeight()
				local bl=BuffFrame[index].Window:GetLeft()
				local br=BuffFrame[index].Window:GetRight()
				local bt=BuffFrame[index].Window:GetTop()
				local bb=BuffFrame[index].Window:GetBottom()
				
				--Default - stay where you are!
				local x=l
				local y=t
				
				--Zone 1; r is inside a zone bl-near to bl+near
					if r>bl-near and r<bl+near then
						x=bl-w
						--Zone 1a: Square at top left
							if t>=bt-near and t<=bt+near then		y=bt end
						--Zone 1b: Square at bottom left
							if b>=bb-near and b<=bb+near then 	y=bb-h end
						return self.Window:SetPosition(x,y)
					end
				--Zone 2; l is inside a zone br-near to br+near
					if l>br-near and l<br+near then
						x=br
						--Zone 2a: Square at top right
							if t>=bt-near and t<=bt+near then		y=bt end
						--Zone 2b: Square at bottom right
							if b>=bb-near and b<=bb+near then 	y=bb-h end
						return self.Window:SetPosition(x,y)
					end
				--Zone 3; b is inside a zone bt-near to bt+near
					if b>bt-near and b<bt+near then
						y=bt-h
						--Zone 3a: Square at top left
							if l>=bl-near and l<=bl+near then		x=bl end
						--Zone 3b: Square at top right
							if r>=br-near and r<=br+near then 		x=br-w end
						return self.Window:SetPosition(x,y)
					end
				--Zone 4; t is inside a zone bb-near to bb+near
					if t>bb-near and t<bb+near then
						y=bb
						--Zone 4a: Square at bottom left
							if l>=bl-near and l<=bl+near then		x=bl end
						--Zone 4b: Square at bottom right
							if r>=br-near and r<=br+near then 		x=br-w end
						return self.Window:SetPosition(x,y)
					end
		end
	end
end
end

--Returns the distance between two points	
function PointDistance (x1,y2,x2,y2)
	local d=(math.sqrt((x2-x1)^2+(y2-y1)^2))
	return d
end
--Returns the distance between point (x1,y1) and the line joining x2,y2,x3,y3
--Note: As all my lines are horizontal or vertical this is much, much simpler than it would be otherwise.
function LineDistance(x1,y1,x2,y2,x3,y3)
	if x2==x3 then --this is a vertical line
		--Check to see if y1 is inbetween y2 and y3 - otherwise return nil. If it is the distance is just the difference between the x-ordinates.
		if (y1>=y2 and y1<=y3) or (y1>=y3 and y1<=y2)	then return math.abs(x2-x1) else return nil end
	elseif y2==y3 then --this is a horizontal line
		--Check to see if x1 is inbetween x2 and x3 - otherwise return nil. If it is the distance is just the difference between the y-ordinates.
		if (x1>=x2 and x1<=x3) or (x1>=x3 and x1<=x2)	then return math.abs(y2-y1) else return nil end
	else	--Pair are not vertical or horizontal. I do not need to consider this!
		return nil
	end
end
		
function rectdistance(list1,list2)
--	list1={{x1,y1},{x2,y2},{x3,y3},{x4,y4}},list2={{x5,y5},{x6,y6},{x7,y7},{x8,y8}}
	
	--Define Variable to hold minimum distance
	local mindist=2000
	--Right, I need to test x1,y1 agains all of x5,y5,x6,y6,x7,y7,x8,y8 and the Vertical/Horizontal line segments joining these
		--Test all point distances
		for i=1,4 do
			for j=1,4 do
				local d=PointDistance(list1[i][1],list1[i][2],list2[j][1],list2[j][2])
				if d<mindist then mindist=d end
			end
		end
		
		--Now, to test all line distances
		
		for i=1,4 do
			for j=1,3 do
				for k=j+1,4 do
					d=LineDistance(list1[i][1],list1[i][2],list2[j][1],list2[j][2],list2[k][1],list2[k][2])
					if d~=nil then if d<mindist then mindist=d end end
				end
			end
		end
		
		for i=1,4 do
			for j=1,3 do
				for k=j+1,4 do
					d=LineDistance(list2[i][1],list2[i][2],list1[j][1],list1[j][2],list1[k][1],list1[k][2])
					if d~=nil then if d<mindist then mindist=d end end
				end
			end
		end
	
		return mindist
end

		

